
------------------------------------
OLAP֐̊{\
------------------------------------

CREATE TABLE Accounts
(account_id   CHAR(1) NOT NULL,
 record_date  DATE    NOT NULL,
 prc_amt 	  INTEGER NOT NULL,
   PRIMARY KEY (account_id, record_date));



DELETE FROM Accounts ;
INSERT INTO Accounts VALUES ('A',	'2010-01-16',	1000    );
INSERT INTO Accounts VALUES ('A',	'2010-01-17',	20000   );
INSERT INTO Accounts VALUES ('A',	'2010-01-18',	-3000   );
INSERT INTO Accounts VALUES ('A',	'2010-01-19',	-500000 );
INSERT INTO Accounts VALUES ('A',	'2010-01-20',	23000   );
INSERT INTO Accounts VALUES ('B',	'2010-01-16',	48000   );
INSERT INTO Accounts VALUES ('B',	'2010-01-17',	98000   );
INSERT INTO Accounts VALUES ('B',	'2010-01-18',	-5000   );
INSERT INTO Accounts VALUES ('B',	'2010-01-19',	30000   );
INSERT INTO Accounts VALUES ('B',	'2010-01-20',	-100000 );
INSERT INTO Accounts VALUES ('C',	'2010-01-16',	5000    );
INSERT INTO Accounts VALUES ('C',	'2010-01-17',	12000   );
INSERT INTO Accounts VALUES ('C',	'2010-01-18',	30000   );
INSERT INTO Accounts VALUES ('C',	'2010-01-19',	1000    );
INSERT INTO Accounts VALUES ('C',	'2010-01-20',	500     );


--MySQLȊOiSQL ServerłORDER BYO邱Ɓj
SELECT account_id,
	   record_date,
       prc_amt,
       AVG(prc_amt) OVER (PARTITION BY account_id
                              ORDER BY record_date) AS cumulative_avg
  FROM Accounts;


--MySQL
SELECT account_id,
	   record_date,
       prc_amt,
       (SELECT AVG(prc_amt)
          FROM Accounts A2
         WHERE A1.account_id = A2.account_id
           AND A1.record_date >= A2.record_date ) AS cumulative_avg
  FROM Accounts A1;


------------------------------------
OLAPp֐
------------------------------------


--OLAPp֐͈ȂFMySQLȊO
SELECT account_id,
	   record_date,
       prc_amt,
       RANK() OVER (PARTITION BY account_id
                        ORDER BY prc_amt DESC) AS rank_amt
  FROM Accounts;


--OLAPp֐͈ȂFMySQL
SELECT account_id,
	   record_date,
       prc_amt,
       (SELECT COUNT(*)
          FROM Accounts A2
         WHERE A1.account_id = A2.account_id
           AND A1.prc_amt < A2.prc_amt ) + 1 AS rank_amt
  FROM Accounts A1;


------------------------------------
Ώۍs𐧌OLAP֐
------------------------------------

--ړρi3R[hƁjFMySQLȊO
SELECT account_id,
	   record_date,
       prc_amt,
       AVG(prc_amt) OVER (PARTITION BY account_id
                              ORDER BY record_date
                               ROWS 2 PRECEDING) AS cumulative_avg_3
  FROM Accounts;




------------------------------------
OLAP֐ƏW֐gݍ킹
------------------------------------


--Ƃ̏z̍vŃLOFMySQLȊO
SELECT record_date,
       SUM(prc_amt) sum_prc_amt,
       RANK() OVER (ORDER BY SUM(prc_amt) DESC) AS rank_sum
  FROM Accounts
 GROUP BY record_date;


--Ƃ̏z̍vŃLOFMySQL
CREATE VIEW SumByDate (record_date, sum_prc_amt) AS
SELECT record_date,
       SUM(prc_amt) sum_prc_amt
  FROM Accounts
 GROUP BY record_date;

SELECT record_date, 
       sum_prc_amt,
       (SELECT COUNT(*) 
          FROM SumByDate T2
         WHERE T1.sum_prc_amt < T2.sum_prc_amt) + 1 AS rank_sum
  FROM SumByDate T1;

